-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04500 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04500;

--
-- Add new table ROLE_CONFIG_GROUPS that is used to group
-- identically configured roles.
--
create table ROLE_CONFIG_GROUPS (
    ROLE_CONFIG_GROUP_ID bigint not null,
    SERVICE_ID bigint not null,
    ROLE_TYPE varchar(255) not null,
    NAME varchar(255) not null,
    primary key (ROLE_CONFIG_GROUP_ID)
) engine=InnoDB;

-- Service + RoleType + Name must be unique

alter table ROLE_CONFIG_GROUPS
    add unique index(SERVICE_ID, ROLE_TYPE, NAME);

alter table ROLE_CONFIG_GROUPS
    add index FK_ROLE_CONFIG_GROUP_SERVICE (SERVICE_ID),
    add constraint FK_ROLE_CONFIG_GROUP_SERVICE
    foreign key (SERVICE_ID)
    references SERVICES (SERVICE_ID);

-- Add role config group to ROLES

alter table ROLES
    add column ROLE_CONFIG_GROUP_ID bigint;

alter table ROLES
    add index FK_ROLE_ROLE_CONFIG_GROUP (ROLE_CONFIG_GROUP_ID),
    add constraint FK_ROLE_ROLE_CONFIG_GROUP
    foreign key (ROLE_CONFIG_GROUP_ID)
    references ROLE_CONFIG_GROUPS (ROLE_CONFIG_GROUP_ID);
